% Load-balancing scheme 2
%  Simple search

function [at nlevels theta] = at2(at, newtime, iter, dummy)
  at.smoothcount = at.smoothcount + 1;
  
  nlevels = at.nlevels;
  theta = at.theta;
  
  at.shorthist(at.smoothcount) = newtime;

  at.levwait = at.levwait-1;
  at.thetwait = at.thetwait-1;

  if(at.smoothcount == at.smoothiters)
    at.smoothcount = 0;
    smoothtime = mean(at.shorthist);
    
    % If I came from a better place in nlevels, go back
    if(at.levprev < smoothtime)
       at.levprev = inf;     
       at.levmove = -1 * at.levmove;
       nlevels = nlevels + at.levmove;
    else  % new place is better
       at.levprev = inf; 
       if at.levwait < 1 % new move
          at.levwait = at.levinterval;
          nlevels = nlevels + at.levmove;
          at.levprev = smoothtime;
       end
    end 
    % If I came from a better place in theta, go back
    if(at.thetprev < smoothtime)
       at.thetprev = inf;     
       at.thetmove = -1 * at.thetmove;
       theta = theta + at.thetstep*at.thetmove;
    else  % new place is better
       at.thetprev = inf;
       if at.thetwait < 1
          at.thetwait = at.thetinterval;    
          theta = theta + at.thetmove*at.thetstep;
          at.thetprev = smoothtime;
       end
    end 
  end
  
  if(nlevels < 2)
     nlevels = 2;
  end
  if(theta < 0.2)
    theta = 0.2;
  elseif(theta > 0.8)
    theta = 0.8;
  end
  at.nlevels = nlevels;
  at.theta = theta;
