function create_plots_timeseries(file, dualplot)

if nargin < 2
  dualplot = 0;
end


load(file)

time(time(:,9)<0,9) = 0; 
time(time(:,9)>100,9) = 0;
time(time(:,1)>100,1) = 0;

if dualplot
figure()
subplot(2,1,1)
plotyy([1:k],nlevs,[1:k],thets)
h = legend('N_{levels}','\theta','Location','EO');
set(h,'FontSize',10);
subplot(2,1,2)
plot([1:k],time(1:k,9),'b',[1:k],time([1:k],1),'g')
h = legend('runtime','loadbalance','Location','EO');
set(h,'FontSize',10);
h = xlabel('Iteration'); set(h,'FontSize',10);
h = ylabel('Time per iteration'); set(h,'FontSize',10);
else
figure()
[ax h1 h2] = plotyy([1:k],nlevs,[1:k],thets)
set(ax(1),{'ycolor' 'ylim'},{'k' [4,8]})
set(ax(2),'ycolor','k')
set(h1,{'LineStyle' 'Color'},{'-.' 'k'})
set(h2,{'LineStyle' 'Color'},{'-' 'b'})
h = legend('N_{levels}','\theta','Location','NW');
set(h,'FontSize',10);
h = xlabel('Iteration'); set(h,'FontSize',10);
end

set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 150]);

print -depsc examples/figs/timeseries_both.eps
