function create_plots_cylinderflow_levcost(errorplot)
% create plots for cylinderflow nlev cost sensitivity experiment

if nargin < 1
  errorplot = 1;
end

numreps = 5;
numruns = 26;
for run = 1:numruns
 run
 for rep = 1:numreps   
 rep
   load(strcat('examples/data/cylinderflow_levcostrun',int2str(run),'rep',int2str(rep),'.mat'))
    time(time(:,9)<0,9) = 0; 
    %time(time(:,9)>100,9) = 0;
    times(run,rep) = sum(time(:,9)); %totaltime;
actualcost(run,rep) = (at.offtimeup + at.offtimedown + at.basetime)/at.basetime;
    runs(run,rep) = run;   
    leg(run) = at.nlevprop;
 end

end


figure()
h = plot(leg,mean(times,2),'k-');
hold on
%plot([.1 .25],[580 667],'k--') % handmade trendline
hold  off
if errorplot
  stddev = std(times,0,2);
  hold on
  %h = errorbar(leg,mean(times,2),mean(times,2)-min(times,[],2),max(times,[],2)-mean(times,2),'k.');
  h = errorbar(leg,mean(times,2),stddev,'k.');
  hold off
end
xlim([0 leg(numruns)])
%set(gca,'XTick', 1:3:numruns)
%set(gca,'XTickLabel', leg(1:2:numruns))
%legend(leg);
%title('cylinderflow tuning cost')
h = xlabel('Tuning cost'); set(h,'FontSize',10);
h = ylabel('Runtime (s)'); set(h,'FontSize',10);

set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 250]);
grid on

print -depsc examples/figs/cylinderflow_levcost_runtime.eps

if false
figure()
h = plot(runs,actualcost,'.');
set(gca,'XTick', 1:2:numruns)
set(gca,'XTickLabel', leg(1:2:numruns))
h = xlabel('Tuning cost'); set(h,'FontSize',10);
h = ylabel('Actual cost'); set(h,'FontSize',10);
end
