% create plots for colliding galaxies experiment

kk=0;
for run = [1:5]
kk=kk+1;

    if run == 1
      ifAT = 0;
      filesuffix = 'none'
    elseif run == 2
      atfunc = @at1;
      ifAT = 1;
      filesuffix = 'at1'
    elseif run == 3
      atfunc  = @at2;
      ifAT = 1;
      filesuffix = 'at2'
    elseif run == 4
      atfunc  = @at3a;
      ifAT = 1;
      filesuffix = 'at3a'
    elseif run == 5
      atfunc  = @at3b;
      ifAT = 1;
      filesuffix = 'at3b'
    end
    
leg(kk) = {filesuffix};
load(strcat('examples/data/cgalaxy_',filesuffix,'.mat'))
time(time(:,9)<0,9) = 0; 
time(time(:,9)>100,9) = 0;
time(time(:,1)>100,1) = 0;
runtimes(kk) = sum(time(:,9)); %totaltime;


%ptime = time(2000:4000,9);
%pnlevs = nlevs(2000:4000);
ptime = time(50:1500,9);
pnlevs = nlevs(50:1500);
basetime = median(ptime(pnlevs==6));
numbase = sum(pnlevs==6);
uptime = median(ptime(pnlevs == 7));
numup = sum(pnlevs==7);
upcost = numup * (uptime-basetime);
downtime = median(ptime(pnlevs == 5));
numdown = sum(pnlevs==5);
downcost = numdown * (downtime-basetime);
basecost = basetime*numbase;
tuningcost = (basecost+downcost+upcost)/basecost

maxabsz = max(abs(z))

figure()
subplot(2,1,1)
title(leg(kk))
plotyy([1:k],nlevs,[1:k],thets)
legend('nlevels','theta')
subplot(2,1,2)
plot([1:k],time(1:k,9),'b',[1:k],time([1:k],1),'g')
legend('runtime','loadbalance')
end


figure()
plot(runtimes);
%legend(leg);
%title('Colliding galaxy runtime')
xlabel('Autotuning strategy')
ylabel('Runtime')
set(gca,'XTick',1:length(runtimes))
set(gca,'XTickLabel',leg)

figure()
plot(runtimes(1)*ones(size(runtimes))./runtimes);
%legend(leg);
%title('Colliding galaxy speedup')
xlabel('Autotuning strategy')
ylabel('Speedup')
set(gca,'XTick',1:length(runtimes))
set(gca,'XTickLabel',leg)

figure()

h = bar(runtimes(1)*ones(size(runtimes))./runtimes);
set(gca,'XTick',1:length(runtimes))
set(gca,'XTickLabel',leg)
%legend(leg);
%title('Colliding galaxy speedup')
h = xlabel('Autotuning strategy'); set(h,'FontSize',10);
h = ylabel('Speedup'); set(h,'FontSize',10);

set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 250]);
grid on
print -depsc examples/figs/cgalaxy_tuning.eps

if false
figure()
numnum = 0;
for num = 1:500:9001
numnum = numnum + 1;
load(strcat('examples/data/cgalaxy_',int2str(num),'at2.mat'))
subplot(4,5,numnum)
plot(z(1:Nstars/Nstarsplot:Nstars),'k.');
title(strcat('galaxies, t=',num2str(t)));
%axis(4*[-R R -R R])
end
end % fi
