function [times stdevs] = create_plots_galaxy_startconds()
% create plots for galaxy starting condition sensitivity experiment

numplotreps = 3;
reptimes = zeros(3,5,numplotreps);
times = zeros(3,5);
for levrun = 1:5
%startnlevels = 3 + levrun
for thetrun = 1:5
%starttheta = 0.25 + thetrun*0.1
for rep = 1:numplotreps
    load(strcat('examples/data/cgalaxy_startcond',int2str(levrun),int2str(thetrun),'rep',int2str(rep),'.mat'))
    time(time(:,9)<0,9) = 0; 
    %time(time(:,9)>100,9) = 0;
    reptimes(levrun,thetrun, rep) = sum(time(:,9)); %totaltime;    
end
initthetas(thetrun) = starttheta;
end
initnlevels(levrun) = startnlevels;
end

initthetas
initnlevels

times = mean(reptimes,3);
stdevs = std(reptimes,0,3);
mintime = min(min(times));

%surf(levs,thets,times')
%hold on
%surf(levs,thets,reptimes(:,:,1)')
%surf(levs,thets,reptimes(:,:,2)')
%surf(levs,thets,reptimes(:,:,3)')
%surf(levs,thets,reptimes(:,:,4)')
%surf(levs,thets,reptimes(:,:,5)')

figure()
%h = imagesc(times./mintime);
%surf([1:4],[1:5],times(1:5,1:4)./mintime)
contour(times(1:4,:)./mintime,[1 1.01 1.02 1.03 1.04 1.05 1.06 1.07 1.08 1.09 1.1 1.125 1.15 1.175 1.2 1.25])

set(gca, 'XTick',[1:5])
set(gca,'XTickLabel', initthetas)
set(gca, 'YTick',[1:4])
set(gca,'YTickLabel', initnlevels)
colorbar
%legend(leg);
%title('galaxy penalty initial tuning')
h = xlabel('\theta'); set(h,'FontSize',10);
h = ylabel('N_{levels}'); set(h,'FontSize',10);

set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 250]);
grid on

print -depsc examples/figs/galaxy_startconds_runtime.eps
