%%
% initat(nlevels[=5], theta[=0.5]) returns an AutoTuner struct with default initializations
%%
function at = initat(nlevels, theta)

if nargin < 2
   'Default settings: nlevels=5, theta=0.5'
   nlevels = 5;
   theta = 0.5;
end

at.nlevels = nlevels;
at.theta = theta;

at.smoothiters = 3;
at.smoothcount = 0;
at.levprev = inf;
at.levinterval = 5*at.smoothiters;
at.levupinterval = 5*at.smoothiters;
at.levdowninterval = 7*at.smoothiters;
at.levwait = at.levinterval;
at.levmove = 1;
at.levkeep = 0;
at.nlevprop = 0.08;
at.thetprev = inf;
at.thetmove = 1;
at.thetstep = 0.01;
at.thetunit = 0.01;
at.thetinterval = 3*at.smoothiters;
at.thetwait = at.thetinterval;
at.shorthist = inf*ones(at.smoothiters,1);
at.thetkeep = 0;

at.fibiters = 1;
at.f1 = 0;
at.f2 = 1;
at.fibnum = 0;


at.basetime = 0;
at.offtimeup = 0;
at.offtimedown = 0;

