function create_plots_khinstability()
% create plots for K-H instability experiment

times = zeros(2,5)
for count = 1:2 
if(count < 2)
  siz = 'small_'
else
  siz = 'large_'
end

kk=0;
for run = [1:5]
    kk=kk+1;    
    
    if run == 1
      ifAT = 0;
      filesuffix = 'none'
    elseif run == 2
      atfunc = @at1;
      ifAT = 1;
      filesuffix = 'at1'
    elseif run == 3
      atfunc  = @at2;
      ifAT = 1;
      filesuffix = 'at2'
    elseif run == 4
      atfunc  = @at3a;
      ifAT = 1;
      filesuffix = 'at3a'
    elseif run == 5
      atfunc  = @at3b;
      ifAT = 1;
      filesuffix = 'at3b'
    end

    leg(kk) = {filesuffix};
    
    filesuffix = strcat(siz,filesuffix);

    load(strcat('examples/data/kh_',filesuffix,'.mat'))
    times(count,kk) = totaltime;
    
    
   % figure()
   % subplot(2,1,1)
   % plotyy([1:k],nlevs,[1:k],thets)
   % legend('nlevels','theta')
   % subplot(2,1,2)
   % plot([1:k],time(1:k,9),'b',[1:k],time([1:k],1),'g')
   % legend('runtime','loadbalance')    
end
   speedup(count,:) = times(count,1)*ones(size(times(count,:)))./times(count,:);
end

figure()
h = bar(times');
%legend(leg);
%title('K-H instability runtime')
set(gca,'XTickLabel', leg)
h = xlabel('Autotuning strategy'); set(h,'FontSize',10);
h = ylabel('Runtime');set(h,'FontSize',10);
h = legend('Small','Large');set(h,'FontSize',10);


figure()
h = bar(speedup');
set(gca,'XTickLabel', leg)
%legend(leg);
%title('K-H instability speedup')
h = xlabel('Autotuning strategy'); set(h,'FontSize',10);
h = ylabel('Speedup'); set(h,'FontSize',10);
h = legend('Small','Large','Location','NW');set(h,'FontSize',10);

set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 150]);
grid on

print -depsc examples/figs/khinstability_tuning.eps

