% run_all() executes the experiments presented in the paper
% Plots are produced by calling create_all_plots()

function run_all()

% Build fmm2d, fmm2d_log
clear mex;
make_all()

if ~exist('examples/data','dir')
   ! mkdir examples/data
end

% cpu vs gpu
run_khinstability_cpugpu()
run_galaxy_cpugpu()
run_cylinderflow_cpugpu()

% parallelism
run_cputhreads()
run_gputhreads()

% vary theta, static problem
run_cpugpulinear()
run_cpugpuuniform()
run_varythetalinear()
run_varythetauniform()

% galaxy simulations
run_collidegalaxies()
% starting conditions
run_galaxy_startconds()

% Kelvin-Helmholtz instability simulations
run_khinstability_large()
run_khinstability_small()

% cylinderflow simulations
run_cylinderflow_levcost()


