% run_all() executes the experiments presented in the paper
% Plots are produced by calling create_all_plots()

function run_all()

% Build fmm2d, fmm2d_log
clear mex;
make_all_cpu()

if ~exist('examples/data','dir')
   ! mkdir examples/data
end

% parallelism
run_cputhreads()

% galaxy simulations
run_collidegalaxies()
% starting conditions
run_galaxy_startconds()

% Kelvin-Helmholtz instability simulations
run_khinstability_large()
run_khinstability_small()

% cylinderflow simulations
run_cylinderflow_levcost()


