function create_plots_gputhreads(errorplot)

if nargin < 1
  errorplot = 1;
end

load('examples/data/gputhreads.mat');


gputime = mean(gputimereps,2);

for i = 1:length(gputhreads)
  su_gputime(i,:) = gputime(1,:)./gputime(i,:);
end

%  loadbalance = time(1);  
%  partition = time(2);
%  connectivity = time(3);
%  P2M = time(4);
%  M2M = time(5);
%  ML2L = time(6);
%  L2P = time(7);
%  P2P = time(8);
%  runtime = time(9); 

figure()
hold off
plot(gputhreads,gputime(:,9),'k-o','LineWidth',4);
hold on;
plot(gputhreads,gputime(:,2),'k-o','LineWidth',2);
plot(gputhreads,gputime(:,3),'b:o','LineWidth',2);
plot(gputhreads,gputime(:,4),'b-o','LineWidth',2);
plot(gputhreads,gputime(:,5),'r:o','LineWidth',2);
plot(gputhreads,gputime(:,6),'r-o','LineWidth',2);
plot(gputhreads,gputime(:,7),'m-o','LineWidth',2);
plot(gputhreads,gputime(:,8),'g-o','LineWidth',2);
if errorplot
   % get stddev, create box plots
   stddevs = std(gputimereps,0,2);
   h = errorbar(gputhreads,gputime(:,9),stddevs(:,9),'k.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,gputime(:,6),stddevs(:,6),'r.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,gputime(:,7),stddevs(:,7),'m.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,gputime(:,8),stddevs(:,8),'g.');
   errorbar_tick(h,2,'units');   
end
%text(gputhreads(:),0.5*gputime(1,9)*ones(length(gputhreads),1),strcat('nlevels=',int2str(gpunlevels(:))));
%title('Runtime w/ GPU');
h = legend('Total','Partition','Connectivity','P2M','M2M','ML2L','L2P','P2P','Location','EO');
set(h,'FontSize',10);
h = xlabel('Threads'); set(h,'FontSize',10);
h = ylabel('Time per iteration (s)'); set(h,'FontSize',10);
%axis([1e3 5e6 0 20]);
set(gca,'XTick',[1 2 4 8])
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 400 250]);grid on
print -depsc examples/figs/GPUthreads_runtime.eps

figure()
hold off
plot(gputhreads,su_gputime(:,9),'k-o','LineWidth',4);
hold on;
plot(gputhreads,su_gputime(:,2),'k-o','LineWidth',2);
plot(gputhreads,su_gputime(:,3),'b:o','LineWidth',2);
plot(gputhreads,su_gputime(:,4),'b-o','LineWidth',2);
plot(gputhreads,su_gputime(:,5),'r:o','LineWidth',2);
plot(gputhreads,su_gputime(:,6),'r-o','LineWidth',2);
plot(gputhreads,su_gputime(:,7),'m-o','LineWidth',2);
plot(gputhreads,su_gputime(:,8),'g-o','LineWidth',2);
plot(gputhreads,gputhreads,'k-');
if errorplot
% get stddev, create box plots
  for i = 1:length(gputhreads)
    su_stddevs(i,:) = std(gputimereps(1,:,:)./gputimereps(i,:,:),0,2);
  end
   h = errorbar(gputhreads,su_gputime(:,9),su_stddevs(:,9),'k.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,su_gputime(:,6),su_stddevs(:,6),'r.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,su_gputime(:,7),su_stddevs(:,7),'m.');
   errorbar_tick(h,2,'units');   
   h = errorbar(gputhreads,su_gputime(:,8),su_stddevs(:,8),'g.');
   errorbar_tick(h,2,'units');   
end

%text(gputhreads(:),0.2*ones(length(gputhreads),1),strcat('nlevels=',int2str(gpunlevels(:))));
%title('Speedup w/ GPU')
h = legend('Total','Partition','Connectivity','P2M','M2M','ML2L','L2P','P2P','Linear','Location','EO');
h = xlabel('Threads'); set(h,'FontSize',10);
h = ylabel('Speedup'); set(h,'FontSize',10);
%axis([1e3 5e6 0 20]);
set(gca,'XTick',[1 2 4 8])
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 400 250]);
grid on
print -depsc examples/figs/GPUthreads_speedup.eps

if 0
figure()
plot(gputhreads,gputime(:,9)./gputime(:,9),'k-o','LineWidth',4);
hold on;
plot(gputhreads,gputime(:,2)./gputime(:,9),'k-o','LineWidth',2);
plot(gputhreads,gputime(:,3)./gputime(:,9),'b:o','LineWidth',2);
plot(gputhreads,gputime(:,4)./gputime(:,9),'b-o','LineWidth',2);
plot(gputhreads,gputime(:,5)./gputime(:,9),'r:o','LineWidth',2);
plot(gputhreads,gputime(:,6)./gputime(:,9),'r-o','LineWidth',2);
plot(gputhreads,gputime(:,7)./gputime(:,9),'m-o','LineWidth',2);
plot(gputhreads,gputime(:,8)./gputime(:,9),'g-o','LineWidth',2);
legend('Total','Partition','Connectivity','P2M','M2M','ML2L','L2P','P2P');
%title(strcat('Proportion w/ GPU'))
xlabel('Threads')
ylabel('Proportion of runtime')
grid on
print -depsc examples/figs/GPUthreads_proportion.eps
end
