% run_varythetalinear.m -- theta-dependence of performance on linear particle distribution

clear all;

for arch = 1:2
clear mex;
if(arch == 1)
  'CPU'
  fmm = @fmm2d_8threads_cpu;
  load examples/data/cpuuniform.mat
else
  'GPU'
  fmm = @fmm2d_8threads;
  load examples/data/gpuuniform.mat
end

time = 0;

thets = [0.3:0.01:0.75];
numreps = 10;

time = zeros(length(thets), numreps, 9);

k=0;
for theta = 0.3:0.01:0.75
  k=k+1;
  for rep = 1:numreps
    clockstart=clock; 
    [p l] = fmm(z,m,'tol',1e-7,'nlevels',nlevels,'theta',theta,'out','times'); 
    clockelapsed=clock-clockstart;
    runtime=3600*clockelapsed(4)+60*clockelapsed(5)+clockelapsed(6);
    l(9) = runtime;
    time(k,rep,:) = l;
  end
end % done for theta


if(arch == 1)
  cputime = time;
  save('examples/data/cpu_varytheta_linear.mat');
else
  gputime = time; 
  save('examples/data/gpu_varytheta_linear.mat');  
end

end % end arch
