/* direct.h */

/* S. Engblom 2007-07-08 (Revision) */
/* S. Engblom 2007-06-26 */

#ifndef __direct_h
#define __direct_h


#include <math.h>


#include "common.h"



/* Direct evaluation of the potential from N pointmasses (mr,mi) at
   the positions (zr,zi). */
#ifdef __cplusplus   
extern "C"{
#endif


void directInteract(int N,
                    const double *zr,const double *zi,
		    const double *mr,const double *mi,
		    int NE,
		    const double *er,const double *ei,
                    double *pr,double *pi,
		    double *qr,double *qi,int pot,
		    SMOOTHER smooth,double xopt,double cutoff,bool cont);		    

void MPexp_evals_direct(const MPexp *This, int N, int NE,
                double *pr,double *pi,
                double *qr,double *qi,
                const double *er,const double *ei,
                const double *zr,const double *zi,
                const double *mr,const double *mi,
                int pot,SMOOTHER smooth,double xopt,double cutoff,bool cont);
                
void MPexp_eval2_direct(const MPexp *This,
                 double *pr,double *pi,
                 const double *zr,const double *zi,
                 const double *mr,const double *mi,
                 int pot,SMOOTHER smooth,double xopt,double cutoff,bool cont);
                 
void MPexp_eval_direct(const MPexp *This,
                double *qr,double *qi,
                const double *er,const double *ei,
                const double *zr,const double *zi,
                const double *mr,const double *mi,
                int pot,SMOOTHER smooth,double xopt,double cutoff,bool cont);                 

void mpexp_directInteract2(double *pr,double *pi,
                           const double *zr,const double *zi,
                           const double *mr,const double *mi,
                           const int *ix,
                           int begin1,int end1,int begin2,int end2,
                           int pot,SMOOTHER smooth,
                           double cutoff,double shape,double scale);
void mpexp_directInteract(double *qr,double *qi,
                          const double *er,const double *ei,
                          const int *jx,int begin1,int end1,
                          const double *zr,const double *zi,
                          const double *mr,const double *mi,
                          const int *ix,int begin2,int end2,
                          int pot,SMOOTHER smooth,
                          double cutoff,double shape,double scale);
		    
#ifdef __cplusplus		    
}
#endif

#endif /* __direct_h */
