/* fmmshift.h */

/* S. Engblom 2009-10-08 (Revision) */
/* S. Engblom 2009-04-15 (Major revision) */
/* S. Engblom 2007-05-29 */

#ifndef __fmmshift_h
#define __fmmshift_h

#include "fmm.h"

/* Definition of the three shift-operators used by the
   FMM. Performance is critical in general and in particular for the
   m2p-shift. */

void shift_alloc(int p,int pot,int maxm2p);
void shift_free(void);

void shift_m2m(dcmplx r0,dcmplx r1,dcmplx r2,dcmplx r3,
	       dcmplx *this,const dcmplx *that);
void shift_m2ps(dcmplx z0,const void *zi,size_t siz,
		const int *ix,int begin,int end,
		dcmplx *this2,	const dcmplx *that1,
        dcmplx *rpow, dcmplx *wksp1);
void shift_p2p(dcmplx r0,dcmplx r1,dcmplx r2,dcmplx r3,
	       dcmplx *this,const dcmplx *that, dcmplx *wksp);

#endif /* __fmmshift_h */
