/* tl.h -- header file for SuperGlue library interface */

#ifndef __TL_H__
#define __TL_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void *tl_handle_t;
typedef void *tl_thread_info_t;
typedef void (*tl_task_function)(tl_thread_info_t, void *, void **);

void tl_barrier();

void tl_add_task(tl_task_function function,
                 void *args, int argsize,
                 const char *name);

void tl_add_task_dep(tl_task_function function,
                     void *args, int argsize,
                     tl_handle_t *handles,
                     int num_reads, int num_writes, int num_adds,
                     const char *name);

tl_handle_t *tl_create_handles(int num);

void tl_destroy_handles(tl_handle_t *handles, int num);

void *tl_get_workspace(tl_thread_info_t thread_info, int size);

void tl_init(int);
void tl_destroy();

unsigned long long tl_log_time();
void tl_log(const char *name, unsigned long long start, unsigned long long stop);

#ifdef __cplusplus
}
#endif

#endif // __TL_H__

